OpenTTD Source: src/osk_gui.cpp File Reference

OpenTTD Source 1.11.0-RC1

Data Structures | Enumerations | Functions | Variables
osk_gui.cpp File Reference
`#include "stdafx.h"`
`#include "string_func.h"`
`#include "strings_func.h"`
`#include "debug.h"`
`#include "window_func.h"`
`#include "gfx_func.h"`
`#include "querystring_gui.h"`
`#include "video/video_driver.hpp"`
`#include "widgets/osk_widget.h"`
`#include "table/sprites.h"`
`#include "table/strings.h"`
`#include "safeguards.h"`

Go to the source code of this file.

## Data Structures
struct | OskWindow

## Enumerations
enum | KeyStateBits { KEYS_NONE, KEYS_SHIFT, KEYS_CAPS }

## Functions
static void | AddKey (NWidgetHorizontal *hor, int height, int num_half, WidgetType widtype, int widnum, uint16 widdata, int *biggest_index)
| Add a key widget to a row of the keyboard. More...
static NWidgetBase * | MakeTopKeys (int *biggest_index)
| Construct the top row keys (cancel, ok, backspace).
static NWidgetBase * | MakeNumberKeys (int *biggest_index)
| Construct the row containing the digit keys.
static NWidgetBase * | MakeQwertyKeys (int *biggest_index)
| Construct the qwerty row keys.
static NWidgetBase * | MakeAsdfgKeys (int *biggest_index)
| Construct the asdfg row keys.
static NWidgetBase * | MakeZxcvbKeys (int *biggest_index)
| Construct the zxcvb row keys.
static NWidgetBase * | MakeSpacebarKeys (int *biggest_index)
| Construct the spacebar row keys.
void | GetKeyboardLayout ()
| Retrieve keyboard layout from language string or (if set) config file. More...
void | ShowOnScreenKeyboard (Window *parent, int button)
| Show the on-screen keyboard (osk) associated with a given textbox. More...
void | UpdateOSKOriginalText (const Window *parent, int button)
| Updates the original text of the OSK so when the 'parent' changes the original and you press on cancel you won't get the 'old' original text but the updated one. More...
bool | IsOSKOpenedFor (const Window *w, int button)
| Check whether the OSK is opened for a specific editbox. More...

## Variables
char | _keyboard_opt [2][OSK_KEYBOARD_ENTRIES *4+1]
| The number of characters has to be OSK_KEYBOARD_ENTRIES. More...
static WChar | _keyboard [2][OSK_KEYBOARD_ENTRIES]
static byte | _keystate = KEYS_NONE
static const int | HALF_KEY_WIDTH = 7
static const int | INTER_KEY_SPACE = 2
static const NWidgetPart | _nested_osk_widgets []
static WindowDesc | _osk_desc (WDP_CENTER, "query_osk", 0, 0, WC_OSK, WC_NONE, 0, _nested_osk_widgets, lengthof(_nested_osk_widgets))

## Detailed Description

The On Screen Keyboard GUI

Definition in file osk_gui.cpp.

## Function Documentation

## ◆ AddKey()

static void AddKey | ( | NWidgetHorizontal * | hor,
|  | int | height,
|  | int | num_half,
|  | WidgetType | widtype,
|  | int | widnum,
|  | uint16 | widdata,
|  | int * | biggest_index
| ) |  |
| static

Add a key widget to a row of the keyboard.

Parameters

  hor | Row container to add key widget to.
  height | Height of the key (all keys in a row should have equal height).
  num_half | Number of 1/2 key widths that this key has.
  widtype | Widget type of the key. Must be either `NWID_SPACER` for an invisible key, or a `WWT_*` widget.
  widnum | Widget number of the key.
  widdata | Data value of the key widget.
  biggest_index | Collected biggest widget index so far.

Note
  Key width is measured in 1/2 keys to allow for 1/2 key shifting between rows.

Definition at line 228 of file osk_gui.cpp.

Referenced by MakeAsdfgKeys(), MakeNumberKeys(), MakeQwertyKeys(), MakeSpacebarKeys(), MakeTopKeys(), and MakeZxcvbKeys().

## ◆ GetKeyboardLayout()

void GetKeyboardLayout | ( |  | ) |

Retrieve keyboard layout from language string or (if set) config file.

Also check for invalid characters.

Definition at line 355 of file osk_gui.cpp.

References _keyboard_opt, OSK_KEYBOARD_ENTRIES, and StrEmpty().

Referenced by ShowOnScreenKeyboard().

## ◆ IsOSKOpenedFor()

bool IsOSKOpenedFor | ( | const Window * | w,
|  | int | button
| ) |  |

Check whether the OSK is opened for a specific editbox.

Parameters

  w | Window to check for
  button | Editbox of w to check for

Returns
  true if the OSK is opened for button.

Definition at line 442 of file osk_gui.cpp.

References FindWindowById(), Window::parent, OskWindow::text_btn, and WC_OSK.

## ◆ ShowOnScreenKeyboard()

void ShowOnScreenKeyboard | ( | Window * | parent,
|  | int | button
| ) |  |

Show the on-screen keyboard (osk) associated with a given textbox.

Parameters

  parent | pointer to the Window where this keyboard originated from
  button | widget number of parent's textbox

Definition at line 410 of file osk_gui.cpp.

References DeleteWindowById(), GetKeyboardLayout(), and WC_OSK.

## ◆ UpdateOSKOriginalText()

void UpdateOSKOriginalText | ( | const Window * | parent,
|  | int | button
| ) |  |

Updates the original text of the OSK so when the 'parent' changes the original and you press on cancel you won't get the 'old' original text but the updated one.

Parameters

  parent | window that just updated its original text
  button | widget number of parent's textbox to update

Definition at line 425 of file osk_gui.cpp.

References Textbuf::buf, FindWindowById(), free(), OskWindow::orig_str_buf, Window::parent, OskWindow::qs, Window::SetDirty(), stredup(), OskWindow::text_btn, and WC_OSK.

## Variable Documentation

## ◆ _keyboard_opt

char _keyboard_opt[2][OSK_KEYBOARD_ENTRIES *4+1]

The number of characters has to be OSK_KEYBOARD_ENTRIES.

However, these have to be UTF-8 encoded, which means up to 4 bytes per character. Furthermore the string needs to be '\0'-terminated.

Definition at line 26 of file osk_gui.cpp.

Referenced by GetKeyboardLayout().

## ◆ _nested_osk_widgets

const NWidgetPart _nested_osk_widgets[]
| static

Initial value:
= {
NWidget(WWT_CAPTION, COLOUR_GREY, WID_OSK_CAPTION), SetDataTip(STR_WHITE_STRING, STR_NULL),
NWidget(WWT_PANEL, COLOUR_GREY),
NWidget(WWT_EDITBOX, COLOUR_GREY, WID_OSK_TEXT), SetMinimalSize(252, 12), SetPadding(2, 2, 2, 2),
EndContainer(),
NWidget(WWT_PANEL, COLOUR_GREY), SetPIP(5, 2, 3),
NWidgetFunction(MakeTopKeys), SetPadding(0, 3, 0, 3),
NWidgetFunction(MakeNumberKeys), SetPadding(0, 3, 0, 3),
NWidgetFunction(MakeQwertyKeys), SetPadding(0, 3, 0, 3),
NWidgetFunction(MakeAsdfgKeys), SetPadding(0, 3, 0, 3),
NWidgetFunction(MakeZxcvbKeys), SetPadding(0, 3, 0, 3),
NWidgetFunction(MakeSpacebarKeys), SetPadding(0, 3, 0, 3),
EndContainer(),
}

Definition at line 329 of file osk_gui.cpp.

NWidgetFunction
static NWidgetPart NWidgetFunction(NWidgetFunctionType *func_ptr)
Obtain a nested widget (sub)tree from an external source.
Definition: widget_type.h:1145
SetPadding
static NWidgetPart SetPadding(uint8 top, uint8 right, uint8 bottom, uint8 left)
Widget part function for setting additional space around a widget.
Definition: widget_type.h:1045
MakeQwertyKeys
static NWidgetBase * MakeQwertyKeys(int *biggest_index)
Construct the qwerty row keys.
Definition: osk_gui.cpp:274
WWT_CAPTION
@ WWT_CAPTION
Window caption (window title between closebox and stickybox)
Definition: widget_type.h:59
MakeSpacebarKeys
static NWidgetBase * MakeSpacebarKeys(int *biggest_index)
Construct the spacebar row keys.
Definition: osk_gui.cpp:315
WID_OSK_CAPTION
@ WID_OSK_CAPTION
Caption of window.
Definition: osk_widget.h:15
MakeZxcvbKeys
static NWidgetBase * MakeZxcvbKeys(int *biggest_index)
Construct the zxcvb row keys.
Definition: osk_gui.cpp:301
SetDataTip
static NWidgetPart SetDataTip(uint32 data, StringID tip)
Widget part function for setting the data and tooltip.
Definition: widget_type.h:1013
MakeNumberKeys
static NWidgetBase * MakeNumberKeys(int *biggest_index)
Construct the row containing the digit keys.
Definition: osk_gui.cpp:262
WWT_EDITBOX
@ WWT_EDITBOX
a textbox for typing
Definition: widget_type.h:69
EndContainer
static NWidgetPart EndContainer()
Widget part function for denoting the end of a container (horizontal, vertical, WWT_FRAME,...
Definition: widget_type.h:998
MakeTopKeys
static NWidgetBase * MakeTopKeys(int *biggest_index)
Construct the top row keys (cancel, ok, backspace).
Definition: osk_gui.cpp:250
MakeAsdfgKeys
static NWidgetBase * MakeAsdfgKeys(int *biggest_index)
Construct the asdfg row keys.
Definition: osk_gui.cpp:288
NWidget
static NWidgetPart NWidget(WidgetType tp, Colours col, int16 idx=-1)
Widget part function for starting a new 'real' widget.
Definition: widget_type.h:1113
SetMinimalSize
static NWidgetPart SetMinimalSize(int16 x, int16 y)
Widget part function for setting the minimal size.
Definition: widget_type.h:946
WWT_PANEL
@ WWT_PANEL
Simple depressed panel.
Definition: widget_type.h:48
WID_OSK_TEXT
@ WID_OSK_TEXT
Edit box.
Definition: osk_widget.h:16
SetPIP
static NWidgetPart SetPIP(uint8 pre, uint8 inter, uint8 post)
Widget part function for setting a pre/inter/post spaces.
Definition: widget_type.h:1075